/*
 * Copyright (c) 2003 Patrick van Staveren <pvanstav@cs.wmich.edu>
 * Copyright (c) 2005 Mario Streiber <mario.streiber@gmx.de>
 * Copyright (c) 2005-2009 Kemal Ilgar Eroglu <ilgar_eroglu@yahoo.com> 
 * 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <xmms/xmmsctrl.h>
#include<stdio.h>

#include "libcommon.h"

gboolean player_init (gpointer cdata) {
	return;	
}	

gboolean player_deinit (gpointer cdata) {
	return;	
}	

void player_save_special_options (gpointer cdata) {
	
}

void player_read_special_options (gpointer cdata) {
	
}

void player_populate_special_options (gpointer cdata) {
	
}

gboolean player_update_special_options (gpointer cdata) {

	return FALSE;
}

guint player_get_menu_options (gpointer cdata) {

  return( ITEM_ADD | ITEM_OPEN | ITEM_CLEAR | ITEM_REPEAT | ITEM_SHUFFLE | ITEM_VIEW_MAIN | ITEM_VIEW_PL |ITEM_VIEW_EQ | ITEM_PREFS | ITEM_POWER );
  
}


void player_playlist (gpointer cdata, gchar ** list, gint num, gboolean enqueue) {
	
	return;
}


void  player_play (gpointer cdata) {
	
	
	xmms_remote_play ( ((plugin_data *) cdata)->xmms_session);
}	


void player_pause (gpointer cdata) {
	
	xmms_remote_pause ( ((plugin_data *) cdata)->xmms_session);
}


void player_stop (gpointer cdata) {
	
	xmms_remote_stop ( ((plugin_data *) cdata)->xmms_session);
}

gboolean player_is_playing (gpointer cdata) {
	
	return xmms_remote_is_playing ( ((plugin_data *) cdata)->xmms_session);
}


gboolean player_is_paused (gpointer cdata) {
	
	return xmms_remote_is_paused ( ((plugin_data *) cdata)->xmms_session);

}


gint player_get_playlist_pos (gpointer cdata) {
	
	return xmms_remote_get_playlist_pos ( ((plugin_data *) cdata)->xmms_session);

}


void player_set_playlist_pos (gpointer cdata, gint pos) {
	
	xmms_remote_set_playlist_pos ( ((plugin_data *) cdata)->xmms_session, pos);

}


gint player_get_playlist_length (gpointer cdata) {
	
	return xmms_remote_get_playlist_length ( ((plugin_data *) cdata)->xmms_session);

}


gint player_get_output_time (gpointer cdata) {
	
	return xmms_remote_get_output_time ( ((plugin_data *) cdata)->xmms_session)/1000;

}

void player_jump_to_time (gpointer cdata, gint pos) {
	
	xmms_remote_jump_to_time ( ((plugin_data *) cdata)->xmms_session, pos *1000);
	
}


void player_get_volume (gpointer cdata, gint * vl, gint * vr) {
	
	xmms_remote_get_volume ( ((plugin_data *) cdata)->xmms_session, vl, vr);

}


void player_set_volume (gpointer cdata, gint vl, gint vr) {
	
	xmms_remote_set_volume ( ((plugin_data *) cdata)->xmms_session, vl, vr);

}


gchar * player_get_playlist_file (gpointer cdata, gint pos) {
	
	return g_strdup(xmms_remote_get_playlist_file ( ((plugin_data *) cdata)->xmms_session, pos));

}


gchar * player_get_playlist_title (gpointer cdata, gint pos) {
	
	return g_locale_to_utf8 (xmms_remote_get_playlist_title ( ((plugin_data *) cdata)->xmms_session, pos), -1, NULL, NULL, NULL);

}


gint player_get_playlist_time (gpointer cdata, gint pos) {
	
	return xmms_remote_get_playlist_time ( ((plugin_data *) cdata)->xmms_session, pos)/1000;

}

void player_show_prefs_box (gpointer cdata) {
	
	xmms_remote_show_prefs_box ( ((plugin_data *) cdata)->xmms_session);
	
}

void player_eject (gpointer cdata) {
	
	xmms_remote_eject ( ((plugin_data *) cdata)->xmms_session);

}


void player_playlist_prev (gpointer cdata) {
	
	xmms_remote_playlist_prev ( ((plugin_data *) cdata)->xmms_session);
	
}


void player_playlist_next (gpointer cdata) {
	
	xmms_remote_playlist_next ( ((plugin_data *) cdata)->xmms_session);
}


gboolean player_is_running (gpointer cdata) {
	
	return xmms_remote_is_running ( ((plugin_data *) cdata)->xmms_session);

}


void  player_quit (gpointer cdata) {
	
	xmms_remote_quit ( ((plugin_data *) cdata)->xmms_session);
}

void  player_play_pause (gpointer cdata) {
	
	xmms_remote_play_pause ( ((plugin_data *) cdata)->xmms_session);
}

gchar *  player_get_version (gpointer cdata) {

		
	return g_strdup_printf("%d",xmms_remote_get_version( ((plugin_data *) cdata)->xmms_session));
}


void  player_playlist_add (gpointer cdata, GList * list) {
	
	
	xmms_remote_playlist_add ( ((plugin_data *) cdata)->xmms_session,	list);
}


void  player_playlist_delete (gpointer cdata, gint pos) {

	
	xmms_remote_playlist_delete ( ((plugin_data *) cdata)->xmms_session, pos);	
}


void  player_main_win_toggle (gpointer cdata, gboolean show) {

	
	xmms_remote_main_win_toggle ( ((plugin_data *) cdata)->xmms_session, show);
}


void  player_pl_win_toggle (gpointer cdata, gboolean show) {
	
		
	xmms_remote_pl_win_toggle ( ((plugin_data *) cdata)->xmms_session, show);
}


void  player_eq_win_toggle (gpointer cdata, gboolean show) {

		
	xmms_remote_eq_win_toggle ( ((plugin_data *) cdata)->xmms_session, show);
}


gboolean  player_is_main_win (gpointer cdata) {

	
	return xmms_remote_is_main_win ( ((plugin_data *) cdata)->xmms_session);

}


gboolean  player_is_pl_win (gpointer cdata) {

		
	return xmms_remote_is_pl_win ( ((plugin_data *) cdata)->xmms_session);
}


gboolean  player_is_eq_win (gpointer cdata) {

			
	return xmms_remote_is_eq_win ( ((plugin_data *) cdata)->xmms_session);
}


void  player_playlist_add_url_string (gpointer cdata, gchar * string) {

		
	xmms_remote_playlist_add_url_string ( ((plugin_data *) cdata)->xmms_session, string);
}

void  player_toggle_repeat (gpointer cdata) {

	
	xmms_remote_toggle_repeat ( ((plugin_data *) cdata)->xmms_session);
}

void  player_toggle_shuffle (gpointer cdata) {

	
	xmms_remote_toggle_shuffle ( ((plugin_data *) cdata)->xmms_session);	
}


gboolean  player_is_repeat (gpointer cdata) {
	
	
	return xmms_remote_is_repeat ( ((plugin_data *) cdata)->xmms_session);
}	


gboolean  player_is_shuffle (gpointer cdata) {

	
	return xmms_remote_is_shuffle ( ((plugin_data *) cdata)->xmms_session);	
}


void  player_playlist_clear (gpointer cdata) {
	
	
	xmms_remote_playlist_clear( ((plugin_data *) cdata)->xmms_session);	
}
	
void  player_show_jtf_box (gpointer cdata) {
	
}

void player_toggle_aot (gpointer cdata, gboolean ontop) {

	
	xmms_remote_toggle_aot( ((plugin_data *) cdata)->xmms_session, ontop);
	
}
